var http = require("http");
var exports=module.exports = {};
getip2location=function(ip, cback) {
	var options = { protocol:'http:',  host: 'ipinfo.io', port:80, path: '/'+ip+'/json', method:'GET' };
	var callback = function(response) {
	  var str = '';	
	  response.on('data', function (chunk) {
		str += chunk;
	  });	
	  response.on('end', function () {
		cback(str);
	  });
	}	
	var request=http.request(options, callback);	
	request.on('error', function(err) {
        console.error('Error with the request:', err.message);        
	});	
	request.end();
}
exports.ip2nearestairport=function(ip, clback) {
	var location={};
	getip2location(ip, function(location) { 
		var locations=JSON.parse(location);
		var options = { protocol:'http:',  host: 'travelpayouts.com', port:80, path: '/whereami?locale=en&ip='+ip, method:'GET' };
		var callback = function(response) {
		  var str = '';	
		  response.on('data', function (chunk) {
			str += chunk;
		  });	
		  response.on('end', function () {											   
			var outputVals=JSON.parse(str);
			var coordinates=String(locations.loc).split(",");
			var apcoordinates=String(outputVals.coordinates).split(":");
			//CALCULATE DISTANCE ..
			var lat1=coordinates[0]; var lon1=coordinates[1]; var lat2=apcoordinates[1]; var lon2=apcoordinates[0];
			var radlat1 = Math.PI * lat1/180; var radlat2 = Math.PI * lat2/180; var theta = lon1-lon2; var radtheta = Math.PI * theta/180; var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta); dist = Math.acos(dist); dist = dist * 180/Math.PI; dist = dist * 60 * 1.1515; dist = dist * 1.609344;			
			var jsonval={"ip":locations.ip, "city":(((typeof (locations.city))==="undefined")?"":locations.city), "region":(((typeof (locations.region))==="undefined")?"":locations.region),"country":(((typeof (locations.country))==="undefined")?"":locations.country),"citycenter":(((typeof (locations.loc))==="undefined")?"":locations.loc),"latitude":(((typeof (coordinates[0]))==="undefined")?"":coordinates[0]),"longitude":(((typeof (coordinates[1]))==="undefined")?"":coordinates[1]),"org":locations.org,"host":(((typeof (locations.host))==="undefined")?"":locations.host),"phone":(((typeof (locations.phone))==="undefined")?"":locations.phone),"postal":(((typeof (locations.postal))==="undefined")?"":locations.postal),"nearestairport":(((typeof (outputVals.iata))==="undefined")?"":outputVals.iata),"airportcity":(((typeof (outputVals.name))==="undefined")?"":outputVals.name),"countryname":(((typeof (outputVals.country_name))==="undefined")?"":outputVals.country_name),"airportcoordinate":apcoordinates[1]+","+apcoordinates[0], "airportlatitude":apcoordinates[1],"airportlongitude":apcoordinates[0],"distancefromcitycenter":Number(dist).toFixed(2),"distanceunit":"Km"};
			clback(JSON.stringify(jsonval));	
		  });
		}	
		var request=http.request(options, callback);	
		request.on('error', function(err) {
			console.error('Error with the request:', err.message);        
		});	
		request.end();							
	});		
}
